import processing.opengl.*;
import de.bezier.data.sql.*;
import peasy.*;

PeasyCam cam;
int mCount= 0;
int MaxScale = 0;
MySQL msql;
int [][] LifeYears = new int[6][12];
int [][] PregYears = new int[6][12];
float plotX1, plotY1;
float plotX2, plotY2;
float labelX, labelY;
String [] Years = {"2006", "2007", "2008", "2009", "2010", "2011"};
String [] Months = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
PFont font1 = createFont("Helvetica", 20);
PFont font2 = createFont("Helvetica", 21);

int [] SixValues = new int[6];

float xRotation = 0;
float yRotation = 0;
float zRotation = 0;
float xRotationTarget = 0;
float yRotationTarget = 0;
float zRotationTarget = 0;


void setup(){
  //size(700,500,P3D);
  size(1080, 720, OPENGL);
  colorMode(HSB, 360,100,100);
  frameRate(30);
  smooth();
  
  //setup the camera
  cam = new PeasyCam(this, 300, 200, -600, 1600);
  cam.setMinimumDistance(10);
  cam.setMaximumDistance(1600);
  
  //font = createFont("Helvetica", 26); 
  
  
  
    String savedData[] = loadStrings("savedData1.txt");
  println("QUERY: " + savedData[0]);
  for (int i=1; i < savedData.length; i++) {
    
    String temp[] = split(savedData[i], ",");
    LifeYears[Integer.parseInt(temp[0])-2006] [Integer.parseInt(temp[1])-1] = Integer.parseInt(temp[2]);
    
  }
       savedData = loadStrings("savedData2.txt");
  println("QUERY: " + savedData[0]);
  for (int i=1; i < savedData.length; i++) {
    
    String temp[] = split(savedData[i], ",");
    PregYears[Integer.parseInt(temp[0])-2006] [Integer.parseInt(temp[1])-1] = Integer.parseInt(temp[2]);
    
  }
}


void draw() {
  background(0);
  //smoothly animate to the target rotation
  xRotation = xRotation + ((xRotationTarget-xRotation)/20.0);
  yRotation = yRotation + ((yRotationTarget-yRotation)/20.0);
  zRotation = zRotation + ((zRotationTarget-zRotation)/20.0);
  if(!mousePressed){cam.setRotations(xRotation,yRotation,zRotation);}
  
  
  //lighting
  /*float dirY = (mouseY / float(height) - 0.5) * 2;
  float dirX = (mouseX / float(width) - 0.5) * 2;
  directionalLight(204, 204, 204, -dirX, -dirY, -1);*/ 
  
  for(int i = 0;i<6;i++){
      fill(100);
      //text(2005+i,((width-10)/7*i)+65,height-70);
      for(int f = 0;f<12;f++){
        //fill(127,45,20+(float)LifeYears[i][f]/10.0); //adjust shading of boxes?
        //rect((width-100)/7*i,(height-100)/12*f, (width-100)/7,(height-100)/12); 
          //box((width-100)/7*i,(height-100)/12*f, (width-100)/7,(height-100)/12); 
          pushMatrix();
          translate((width-100)/7*i,(height-100)/12*f,0);
          fill(230,90,(20+(float)LifeYears[i][f]/5.0),LifeYears[i][f]/15.0); //adjust color of "Birth" cubes --> BLUE
          //fill(140,80,(20+(float)LifeYears[i][f]/5.0),LifeYears[i][f]/15.0);
          box(20,20,((float)LifeYears[i][f]/8.0)); 
          fill(280,90,(15+(float)PregYears[i][f]/5.0),PregYears[i][f]/3.0); //adjust color of "Pregnancy" cubes --> PURPLE
          translate(20,0,0);
          stroke(100,0,80);
          box(20,20,((float)PregYears[i][f]/2.5));
          //sphere((float)PregYears[i][f]/12.5);

          
          popMatrix();
          
          

        //print mouseX positions
        /*if((abs(mouseX-((width-100)/7*i)) < 50) &&  (abs(mouseY-((height-100)/12*f)) <90)) { //tweak number popup ranges
          fill(110,0,90);
          textAlign(CENTER,CENTER);
          text(LifeYears[i][f],((width-100)/7*i)+50,(height-100)/12*f,100);*/
        }
      }
    
    
    for (int t =0;t<6;t++) {
    textFont(font1);  
    textAlign(CENTER, CENTER);
    //pushMatrix();
    //translate(t*Hside, Vside, 100);
    //rotateX(PI/2.0);
    fill (360);
    text(Years[t], ((width-100)/7*t)+15, -40);
    
   // popMatrix();
  }
    for (int k =0;k<12;k++) {
    textAlign(CENTER, CENTER);
   // pushMatrix();
   // translate(6*Hside+20, Vside, -k*100);
    //rotateX(PI/2.0);
    //rotateZ(-PI/2.0);
    text(Months[k], -75, ((height-100)/12*k));
    //popMatrix();
  }
  //drawBar3D();
  
  //use HUD to write stuff that is stationary in relation to the camera
  cam.beginHUD();
  textFont(font2);
  textAlign(LEFT, CENTER);
  fill(230,85,95);
  text("All SPL Checkouts From 2006-2011 relating to Birth", 10, 20);
  fill(280,95,95);
  text("All SPL Checkouts From 2006-2011 relating to Pregnancy", 10, 50);
  //stroke(0,0,85);
  cam.endHUD();
}


void drawBar3D() {

  float  Hside;
  float Vside;
  float Zside;
  //background(255, 120, 50); //peachy color 
  strokeWeight(1); 
  Hside = 100;
  Vside = 100;
  Zside = 100;

  fill(60, 80, 140, 120); //160,180,240,120
  stroke(220, 210, 5); //220,210,5
  //The total 
  for (int k=0; k <12; k++) {
    for (int t =0;t<6;t++) {
      float NewHeigh = map(LifeYears[t][k], 0, MaxScale, 0, Vside);
      //      box(plotX1+t*Hside, plotY2-NewHeigh,floor(Hside*.95),NewHeigh);
      pushMatrix();
      translate(t*Hside, Vside-NewHeigh/2.0, -100*k);
      box(Hside*.95, NewHeigh, 95);
      popMatrix();
    }
  }

  // Labeling
  textFont(font1); 
  fill(255);
  
  for (int t =0;t<6;t++) {
    textAlign(CENTER, CENTER);
    pushMatrix();
    translate(t*Hside, Vside, 100);
    //rotateX(PI/2.0);
    text(Years[t], 0, 0);
    popMatrix();
  }
  for (int k =0;k<12;k++) {
    textAlign(CENTER, CENTER);
    pushMatrix();
    translate(6*Hside+20, Vside, -k*100);
    //rotateX(PI/2.0);
    //rotateZ(-PI/2.0);
    text(Months[k], 0, 0);
    popMatrix();
  }
}


void keyPressed() {
  if (key == 'r') {
    cam.reset(1000);
  } 

  if (key == 'a') {  //Press "a" key for random camera flip --> controls below
    cam.rotateY(PI/2.0);
    cam.lookAt(random(-100.0,50.0),random(-200.0,100.0),random(-100.0,300.0), 1000);
    xRotationTarget = random(10.0);
    yRotationTarget = random(1.0);
    zRotationTarget = random(1.0);
  }
}

void mouseReleased(){
    float[] rotations = cam.getRotations();
    xRotation = rotations[0];
    yRotation = rotations[1];
    zRotation = rotations[2];
    xRotationTarget = rotations[0];
    yRotationTarget = rotations[1];
    zRotationTarget = rotations[2];    
}

