import processing.opengl.*;
import de.bezier.data.sql.*;
import peasy.*;

PeasyCam cam;
int mCount= 0;
int MaxScale = 0;
MySQL msql;
int [][] Veg2009 = new int[6][12];
float plotX1, plotY1;
float plotX2, plotY2;
float labelX, labelY;
String [] Veglabel = {"Bean", "Carrot", "Lemon", "Potato", "Pumpkin", "Tomato"};
String [] Months = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
PFont font;
int [] SixValues = new int[6];

float xRotation = 0;
float yRotation = 0;
float zRotation = 0;
float xRotationTarget = 0;
float yRotationTarget = 0;
float zRotationTarget = 0;


void setup(){
  //size(700,500,P3D);
  size(700, 500, OPENGL);
  frameRate(30);
  smooth();
  
  //setup the camera
  cam = new PeasyCam(this, 300, 0, -600, 1200);
  cam.setMinimumDistance(10);
  cam.setMaximumDistance(1600);
  
  font = createFont("Helvetica", 20); 
  
  // connecting to the database
  String user     = "mat259";
  String pass     = "V1sual1zat1on";
  String database = "spl_all";
  String TheQuery ="";
  String TextToSearch ="";
  String TheFile = "2009Monthly.txt";
  String lines[] = loadStrings(TheFile);
  msql = new MySQL( this, "tango.mat.ucsb.edu", database, user, pass );

  if ( msql.connect() ){ 
    for (int t =0; t<6;t++) {
      for (int k =0 ; k < 12; k++) {
        TheQuery="SELECT count(*) FROM transactionsallID WHERE id BETWEEN " + lines[2*k] + " and " + lines[2*k+1] ;
        TheQuery+= " and (title like '%" + Veglabel[t] + "%')";
        msql.query( TheQuery);
        msql.next();
        Veg2009[t][k]= msql.getInt(1);
        // Saving the Maximum
        if (Veg2009[t][k] >  MaxScale) {
          MaxScale = Veg2009[t][k];
        }
        println(k + "  " + Veglabel[t]+ "  " +  msql.getInt(1));
      }
    }
  }
  else
  {
    println(" connection failed ");
  }
}


void draw() {
  background(0);
  //smoothly animate to the target rotation
  /*xRotation = xRotation + ((xRotationTarget-xRotation)/20.0);
  yRotation = yRotation + ((yRotationTarget-yRotation)/20.0);
  zRotation = zRotation + ((zRotationTarget-zRotation)/20.0);
  if(!mousePressed){cam.setRotations(xRotation,yRotation,zRotation);}
  */
  
  //lighting
  /*float dirY = (mouseY / float(height) - 0.5) * 2;
  float dirX = (mouseX / float(width) - 0.5) * 2;
  directionalLight(204, 204, 204, -dirX, -dirY, -1);*/ 
  
  drawBar3D();
  
  //use HUD to write stuff that is stationary in relation to the camera
  cam.beginHUD();
  textAlign(LEFT, CENTER);
  fill(255);
  text("stationary text is written between cam.beginHUD() and cam.endHUD()", 10, 10);
  text("xRotation: " + xRotationTarget + " yRotation: " + yRotationTarget + " zRotation: " + zRotationTarget, 10, 30);
  cam.endHUD();
}


void drawBar3D() {

  float  Hside;
  float Vside;
  float Zside;
  //background(255, 120, 50); //peachy color 
  strokeWeight(1); 
  Hside = 100;
  Vside = 100;
  Zside = 100;

  fill(60, 80, 140, 120); //160,180,240,120
  stroke(220, 210, 5); //220,210,5
  //The total 
  for (int k=0; k <12; k++) {
    for (int t =0;t<6;t++) {
      float NewHeigh = map(Veg2009[t][k], 0, MaxScale, 0, Vside);
      //      box(plotX1+t*Hside, plotY2-NewHeigh,floor(Hside*.95),NewHeigh);
      pushMatrix();
      translate(t*Hside, Vside-NewHeigh/2.0, -100*k);
      box(Hside*.95, NewHeigh, 95);
      popMatrix();
    }
  }

  // Labeling
  textFont(font); 
  fill(255);
  
  for (int t =0;t<6;t++) {
    textAlign(CENTER, CENTER);
    pushMatrix();
    translate(t*Hside, Vside, 100);
    rotateX(PI/2.0);
    text(Veglabel[t], 0, 0);
    popMatrix();
  }
  for (int k =0;k<12;k++) {
    textAlign(CENTER, CENTER);
    pushMatrix();
    translate(6*Hside+20, Vside, -k*100);
    rotateX(PI/2.0);
    rotateZ(-PI/2.0);
    text(Months[k], 0, 0);
    popMatrix();
  }
}


void keyPressed() {
  if (key == 'r') {
    cam.reset(5000);
  } 

  if (key == 'a') {
    cam.rotateY(PI/2.0);
    //cam.lookAt(random(-100.0,50.0),random(-200.0,100.0),random(-100.0,300.0), 1000);
    //xRotationTarget = random(10.0);
    //yRotationTarget = random(1.0);
    //zRotationTarget = random(1.0);
  }
}

void mouseReleased(){
    float[] rotations = cam.getRotations();
    xRotation = rotations[0];
    yRotation = rotations[1];
    zRotation = rotations[2];
    xRotationTarget = rotations[0];
    yRotationTarget = rotations[1];
    zRotationTarget = rotations[2];    
}

